MODULE CubeSolving_R

    VAR String SideColors_Test{6}:=
    ["rryrrrbrw",
		"bygwgboyb",
		"rgooobroo",
		"goywbbgby",
		"ogbywgygw",
		"wwwwyogyr"];

    VAR String SideColors{6};
    !Added TCH ColorIdentify
    VAR num SideColorValues{6,9,6}; !6 sides, 9 squares, 6 parameters per square
    

    VAR num Sides{7,3,3}:=[
        [[0,0,0],[0,0,0],[0,0,0]],
        [[0,0,0],[0,0,0],[0,0,0]],
        [[0,0,0],[0,0,0],[0,0,0]],
        [[0,0,0],[0,0,0],[0,0,0]],
        [[0,0,0],[0,0,0],[0,0,0]],
        [[0,0,0],[0,0,0],[0,0,0]],
        [[0,0,0],[0,0,0],[0,0,0]]];

    VAR string Initial_Position{20};

    VAR NUM position{6};

    PROC AdjustColorLocation()
        CopyMatrics 3,7,1;
        CopyMatrics 7,3,0;

        CopyMatrics 1,7,1;
        CopyMatrics 7,1,0;

        !Surface 3(4) is right

        CopyMatrics 2,7,3;
        CopyMatrics 7,2,0;

        !Surface 5(6) is right
        !Surface 4(5) is right

    ENDPROC

    PROC CopyMatrics(num A,num B,num n)
        !Copy from A to B
        !n=0:DirectCopy  1:ClockWiseCopy  2:AntiClockCop  3:Reverse copy
        FOR i FROM 1 TO 3 STEP 1 DO
            FOR j FROM 1 TO 3 STEP 1 DO
                if n=0 THEN
                    Sides{B,i,j}:=Sides{A,i,j};
                ENDIF
                if n=1 THEN
                    Sides{B,j,4-i}:=Sides{A,i,j};
                ENDIF
                if n=2 THEN
                    Sides{B,4-j,i}:=Sides{A,i,j};
                ENDIF
                if n=3 THEN
                    Sides{B,i,j}:=Sides{A,4-i,4-j};
                ENDIF
            ENDFOR
        ENDFOR
        RETURN ;
    ENDPROC

    PROC TransformSidesToThistlethwaite()
        !UF UR UB UL DF DR DB DL FR FL BR BL UFR URB UBL ULF DRF DFL DLB DBR
        !15 12 16 14 35 32 36 34 52 54 62 64 152 126 164 145 325 354 346 362

        VAR string m;
        VAR string n;
        VAR string k;

        !UF 15
        m:=RecognizeColor(Sides{1,3,2});
        n:=RecognizeColor(Sides{5,1,2});
        Initial_Position{1}:=m+n;

        !UR 12
        m:=RecognizeColor(Sides{1,2,3});
        n:=RecognizeColor(Sides{2,2,1});
        Initial_Position{2}:=m+n;

        !UB 16
        m:=RecognizeColor(Sides{1,1,2});
        n:=RecognizeColor(Sides{6,3,2});
        Initial_Position{3}:=m+n;

        !UL 14
        m:=RecognizeColor(Sides{1,2,1});
        n:=RecognizeColor(Sides{4,2,3});
        Initial_Position{4}:=m+n;

        !UF UR UB UL DF DR DB DL FR FL BR BL UFR URB UBL ULF DRF DFL DLB DBR
        !15 12 16 14 35 32 36 34 52 54 62 64 152 126 164 145 325 354 346 362

        !DF 35
        m:=RecognizeColor(Sides{3,3,2});
        n:=RecognizeColor(Sides{5,3,2});
        Initial_Position{5}:=m+n;

        !DR 32
        m:=RecognizeColor(Sides{3,2,1});
        n:=RecognizeColor(Sides{2,2,3});
        Initial_Position{6}:=m+n;

        !DB 36
        m:=RecognizeColor(Sides{3,1,2});
        n:=RecognizeColor(Sides{6,1,2});
        Initial_Position{7}:=m+n;

        !DL 34
        m:=RecognizeColor(Sides{3,2,3});
        n:=RecognizeColor(Sides{4,2,1});
        Initial_Position{8}:=m+n;

        !UF UR UB UL DF DR DB DL FR FL BR BL UFR URB UBL ULF DRF DFL DLB DBR
        !15 12 16 14 35 32 36 34 52 54 62 64 152 126 164 145 325 354 346 362

        !FR 52
        m:=RecognizeColor(Sides{5,2,3});
        n:=RecognizeColor(Sides{2,3,2});
        Initial_Position{9}:=m+n;

        !FL 54
        m:=RecognizeColor(Sides{5,2,1});
        n:=RecognizeColor(Sides{4,3,2});
        Initial_Position{10}:=m+n;

        !BR 62
        m:=RecognizeColor(Sides{6,2,3});
        n:=RecognizeColor(Sides{2,1,2});
        Initial_Position{11}:=m+n;

        !BL 64
        m:=RecognizeColor(Sides{6,2,1});
        n:=RecognizeColor(Sides{4,1,2});
        Initial_Position{12}:=m+n;

        !UF UR UB UL DF DR DB DL FR FL BR BL UFR URB UBL ULF DRF DFL DLB DBR
        !15 12 16 14 35 32 36 34 52 54 62 64 152 126 164 145 325 354 346 362

        !UFR 152
        m:=RecognizeColor(Sides{1,3,3});
        n:=RecognizeColor(Sides{5,1,3});
        k:=RecognizeColor(Sides{2,3,1});
        Initial_Position{13}:=m+n+k;

        !URB 126
        m:=RecognizeColor(Sides{1,1,3});
        n:=RecognizeColor(Sides{2,1,1});
        k:=RecognizeColor(Sides{6,3,3});
        Initial_Position{14}:=m+n+k;

        !UBL 164
        m:=RecognizeColor(Sides{1,1,1});
        n:=RecognizeColor(Sides{6,3,1});
        k:=RecognizeColor(Sides{4,1,3});
        Initial_Position{15}:=m+n+k;

        !ULF 145
        m:=RecognizeColor(Sides{1,3,1});
        n:=RecognizeColor(Sides{4,3,3});
        k:=RecognizeColor(Sides{5,1,1});
        Initial_Position{16}:=m+n+k;

        !UF UR UB UL DF DR DB DL FR FL BR BL UFR URB UBL ULF DRF DFL DLB DBR
        !15 12 16 14 35 32 36 34 52 54 62 64 152 126 164 145 325 354 346 362

        !DRF 325
        m:=RecognizeColor(Sides{3,3,1});
        n:=RecognizeColor(Sides{2,3,3});
        k:=RecognizeColor(Sides{5,3,3});
        Initial_Position{17}:=m+n+k;

        !DFL 354
        m:=RecognizeColor(Sides{3,3,3});
        n:=RecognizeColor(Sides{5,3,1});
        k:=RecognizeColor(Sides{4,3,1});
        Initial_Position{18}:=m+n+k;

        !DLB 346
        m:=RecognizeColor(Sides{3,1,3});
        n:=RecognizeColor(Sides{4,1,1});
        k:=RecognizeColor(Sides{6,1,1});
        Initial_Position{19}:=m+n+k;

        !DBR 362
        m:=RecognizeColor(Sides{3,1,1});
        n:=RecognizeColor(Sides{6,1,3});
        k:=RecognizeColor(Sides{2,1,3});
        Initial_Position{20}:=m+n+k;
    ENDPROC

    FUNC string RecognizeColor(NUM ColorBlock)
        VAR NUM c{6};
        VAR String s{6}:=["U","R","D","L","F","B"];

        c{1}:=Sides{1,2,2};
        c{2}:=Sides{2,2,2};
        c{3}:=Sides{3,2,2};
        c{4}:=Sides{4,2,2};
        c{5}:=Sides{5,2,2};
        c{6}:=Sides{6,2,2};

        FOR i FROM 1 TO 6 DO
            IF ColorBlock=c{i} THEN
                RETURN s{i};
            ENDIF
        ENDFOR

    ENDFUNC


    FUNC string ImportColor(String SideColors{*})
        VAR num Check{6}:=[0,0,0,0,0,0];
        VAR num nColor;
        VAR string szColors;
        VAR num x;
        VAR num y;
        VAR string color_block;

        FOR i FROM 1 TO 6 DO
            szColors:=SideColors{i};
            IF StrLen(szColors)<>9 THEN
                TPWrite "String Length Wrong";
                Return "String Length Wrong";
            ENDIF
            FOR j FROM 1 TO 9 STEP 1 DO
                color_block:=strpart(szColors,j,1);
                nColor:=Color_Value(color_block);
                y:=j mod 3;
                IF y=0 THEN
                    y:=3;
                ENDIF
                x:=(j-y) DIV 3+1;
                Check{nColor}:=Check{nColor}+1;
                Sides{i,x,y}:=nColor;
                if (j=5) Position{i}:=nColor;
            ENDFOR
        ENDFOR

        FOR m FROM 1 TO 6 DO
            IF Check{m}<>9 THEN
                RETURN "color quantity wrong";
            ENDIF
        ENDFOR
        RETURN "";

    ENDFUNC


    FUNC NUM Color_Value(String c)
        if c="Y" or c="y" THEN
            return 1;
        ENDIF
        if c="B" or c="b" THEN
            return 2;
        ENDIF
        if c="R" or c="r" THEN
            return 3;
        ENDIF
        if c="W" or c="w" THEN
            return 4;
        ENDIF
        if c="O" or c="o" THEN
            return 5;
        ENDIF
        if c="G" or c="g" THEN
            return 6;
        else
            return 0;
        ENDIF
    ENDFUNC

ENDMODULE