MODULE mLogger
    VAR iodev datafile;
    VAR string stLog:="ColorFeatures.csv";

    !--------------------------------------------------------------------------------------
    !  Name:     WriteToPort
    !  Purpose:  To Write Strings to com1:
    !--------------------------------------------------------------------------------------    
    PROC WriteToCSV(string str1, bool Append)
        CONST string CrLf:="\0D"+"\0A";
        VAR num nMyErrRetry:=0;

        IF NOT IsFile(diskhome+"/"+stLog) THEN
            Open diskhome\File:=stLog,datafile\Write;
        ELSEIF Append THEN
            Open diskhome\File:=stLog,datafile\Append;
        ELSE
            Open diskhome\File:=stLog,datafile\Write;
        ENDIF
        Write datafile,str1;
        Close datafile;

    ERROR
        !  Error Handler
        TEST ERRNO
        CASE ERR_FILEOPEN:
            IF nMyErrRetry<1 THEN
                ErrWrite\W," Routine WriteToPort:","File Open error",\RL2:="Will Close File and Then Retry";
                Close datafile;
                Incr nMyErrRetry;
                RETRY;
            ENDIF
            ErrWrite\W," Routine WriteToPort:"," File Open error",\RL2:=" Retry Not Succesful";
            RAISE ;

        DEFAULT:
            ErrWrite\W," Routine WriteToPort: ","Unhandled error ",\RL2:="Reported error number "\RL3:=ValToStr(ERRNO);
            Close datafile;
            RAISE ;
        ENDTEST
    ENDPROC

ENDMODULE
